﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@

Sub Class_Globals
	
	Public iCurrentMenuBar As Int
	Public 	iButtonStartIndex As Int
	
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore

	Public arrMenu() As tMenuProps
	Private arrMenuButtons() As B4XView

	Private pnlMenuBar As B4XView
	Private lblMenuTitle As B4XView
	
'	Private B4XPage1 As Page1
'	Private B4XPage2 As Page2
'	Private B4XPage3 As Page3
	
	Private RAF As RandomAccessFile
	Private rp As RuntimePermissions
	Private MES As clsManageExternalStorage
	Private iBytesToCheckForEncloserByte As Int = 1000
	
End Sub

'You can add more parameters here.
Public Sub Initialize
	
	MES.Initialize(Me, "MES") 'clsManageExternalStorage
	
'	B4XPage1.Initialize
'	B4XPage2.Initialize
'	B4XPage3.Initialize
	
End Sub

Sub AllowExternalFilesPermission As ResumableSub
	
	Log("AllowExternalFilesPermission")
	
	'Choose which permission to request in order to access external storgage
	'-----------------------------------------------------------------------
	If General.iSDKVersion < 30 Then
		'Dim rp As RuntimePermissions
		rp.CheckAndRequest(rp.PERMISSION_WRITE_EXTERNAL_STORAGE) ' Implicit read capability if granted
		Wait For B4XPage_PermissionResult(Permission As String, Result As Boolean)
		Return True
	Else
		If Not(MES.HasPermission) Then
			Log("Going to show MsgboxAsync")
			MsgboxAsync("This app requires access to all files, please enable the option", "Manage All Files")
			Wait For Msgbox_Result(Res As Int)
			MES.GetPermission
			Wait For MES_StorageAvailable
			Return True
		End If
	End If
	
	Return True
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Dim i As Int
	
	Root = Root1
	
	'load the layout to Root
	Root.LoadLayout("MenuBarPanel")
	pnlMenuBar.LoadLayout("MenuBar0")
	
	arrMenuButtons = General.GetMenuButtons(pnlMenuBar, iButtonStartIndex)
	
	Log("arrMenuButtons.Length: " & arrMenuButtons.Length)

	Dim rs As ResumableSub = AllowExternalFilesPermission
	Wait For (rs) Complete (bDone As Boolean)
	
	If bDone Then
		
		'----------
		'this works
		'----------
		Dim rs As ResumableSub = MakeMenuArray
		Wait For (rs) Complete (dDoneMenuArray As Boolean)
		
		Log("dDoneMenuArray: " & dDoneMenuArray)
		
		'-----------------
		'this doesn't work
		'-----------------
		'MakeMenuArray
		
		Log("arrMenu.Length: " & arrMenu.Length)
		Log("arrMenuButtons.Length: " & arrMenuButtons.Length)
		
		For i = iButtonStartIndex To arrMenuButtons.Length - 1 'overflow button has no bitmap
			arrMenuButtons(i).SetBitmap(arrMenu(i).bmpIconBitMap1) '<<<<< java.lang.ArrayIndexOutOfBoundsException: length=0; index=0
		Next

	End If
	
'	B4XPages.AddPageAndCreate("Page1", B4XPage1)
'	B4XPages.AddPageAndCreate("Page2", B4XPage2)
'	B4XPages.AddPageAndCreate("Page3", B4XPage3)
	
End Sub

Sub btnMenu_Click
	
	Dim i As Int
	Dim e As B4XView = Sender
	Dim iButtonTag As Int = e.Tag
	
	'ignore items that have no corresponding app panel as for example pnlBP, so ignore overflow buttons
	If arrMenu(iButtonTag).iPanelID <> -1 Then
		For i = iButtonStartIndex To arrMenu.Length - 1 'ignoring hamburger button and other menu groups
			'Log("|" & arrMenu(i).strTitle1 & "|")
			If i = iButtonTag Then
				'clicked button
				If arrMenu(i).bHighlighted = False Then
					arrMenu(i).bHighlighted = True
					arrMenuButtons(i).SetBitmap(arrMenu(i).bmpIconBitMap1HL)
				End If
			Else
				If arrMenu(i).bHighlighted Then
					arrMenu(i).bHighlighted = False
					arrMenuButtons(i).SetBitmap(arrMenu(i).bmpIconBitMap1)
				End If
			End If
		Next
		lblMenuTitle.Text = arrMenu(iButtonTag).strTitle1
	End If
	
	Select Case iButtonTag
		Case 0
			
		Case 1
			
	End Select
End Sub

Sub pnlMenuBar_Touch(Action As Int, X As Float, Y As Float)
	
	If x > lblMenuTitle.Width Then Return
	
	If Action = 1 Then
		If x / lblMenuTitle.Width > 0.5 Then
			ChangeMenuBar(True)
		Else
			ChangeMenuBar(False)
		End If
	End If
	
End Sub

Sub ChangeMenuBar(bUp As Boolean)
	
	pnlMenuBar.RemoveAllViews
	
	If bUp Then
		Select Case iCurrentMenuBar
			Case 0
				iButtonStartIndex = General.eMenuButtonType.Appointments
				pnlMenuBar.LoadLayout("MenuBar1")
				iCurrentMenuBar = 1
			Case 1
				iButtonStartIndex = General.eMenuButtonType.Previous_Patients
				pnlMenuBar.LoadLayout("MenuBar2")
				iCurrentMenuBar = 2
			Case 2
				iButtonStartIndex = General.eMenuButtonType.SQL
				pnlMenuBar.LoadLayout("MenuBar3")
				iCurrentMenuBar = 3
			Case 3
				iButtonStartIndex = General.eMenuButtonType.FindPatient
				pnlMenuBar.LoadLayout("MenuBar0")
				iCurrentMenuBar = 0
		End Select
	Else
		Select Case iCurrentMenuBar
			Case 0
				iButtonStartIndex = General.eMenuButtonType.SQL
				pnlMenuBar.LoadLayout("MenuBar3")
				iCurrentMenuBar = 3
			Case 1
				iButtonStartIndex = General.eMenuButtonType.FindPatient
				pnlMenuBar.LoadLayout("MenuBar0")
				iCurrentMenuBar = 0
			Case 2
				iButtonStartIndex = General.eMenuButtonType.Appointments
				pnlMenuBar.LoadLayout("MenuBar1")
				iCurrentMenuBar = 1
			Case 3
				iButtonStartIndex = General.eMenuButtonType.Previous_Patients
				pnlMenuBar.LoadLayout("MenuBar2")
				iCurrentMenuBar = 2
		End Select
	End If
	
	arrMenuButtons = General.GetMenuButtons(pnlMenuBar, iButtonStartIndex)
	
	For i = iButtonStartIndex To arrMenuButtons.Length - 1 'overflow button has no bitmap
		If arrMenu(i).bHighlighted Then
			arrMenuButtons(i).SetBitmap(arrMenu(i).bmpIconBitMap1HL)
		Else
			arrMenuButtons(i).SetBitmap(arrMenu(i).bmpIconBitMap1)
		End If
	Next
	
End Sub

Sub MakeMenuArray As ResumableSub
	
	Dim i As Int
	Dim arr() As String
	Dim lstCSV As List
	
'	'This doesn't work: no list is produced, although CSV2List runs fine and adds the right number of rows
'	'-----------------------------------------------------------------------------------------------------
	Dim rs As ResumableSub = CSV2List(File.DirRootExternal & "/PhonePats", "menu_props2.csv", True, 44, 34, True, 10, -1)
	Wait For (rs) Complete (lstCSV As List)
'	
	
	'neither of these 2 logs will show, so for some reason this Sub exits/returns here
	'---------------------------------------------------------------------------------
	If lstCSV.IsInitialized Then
		Log("lstCSV.Size (just after making the list): " & lstCSV.Size)
	Else
		Log("lstCSV is not initialized!")
	End If

	'lstCSV = CSV2List(File.DirRootExternal & "/PhonePats", "menu_props2.csv", True, 44, 34, True, 10, -1)
	lstCSV.RemoveAt(0) 'remove the column names array
	
	Dim arrMenu(lstCSV.Size) As tMenuProps
	
	Log("arrMenu.Length: " & arrMenu.Length)
	
	For i = 0 To lstCSV.Size - 1
		
		arr = lstCSV.Get(i)
		Dim tMP As tMenuProps
		
		tMP.iButtonID = arr(0)
		tMP.iMenuPanelID = arr(1)
		tMP.strTitle1 = arr(2)
		tMP.strTitle2 = arr(3)
		tMP.strIconFile1 = arr(4)
		tMP.strIconFile2 = arr(5)
		tMP.iIconFont = arr(6)
		tMP.iIconChar = arr(7)
		tMP.iIconColour = arr(8)
		tMP.bIconBold = arr(9) = 1
		tMP.iTextColour = arr(10)
		tMP.iPanelID = arr(11)
		tMP.iMenuGroup = arr(12)
		tMP.iOverFlowGroup = arr(13)
		tMP.iVerticalAdjust = arr(14)
		tMP.iHorizontalAdjust = arr(15)
		
		If tMP.strIconFile1.Length > 0 Then
			'Log("|" & tMP.strIconFile1 & "| " & i)
			Dim bmp As Bitmap = BitMapFromFile(File.DirAssets, tMP.strIconFile1, 0, 0, True)
			tMP.bmpIconBitMap1 = bmp
			If tMP.iOverFlowGroup = -1 Then
				Dim bmpHL As Bitmap = ReplaceColor(bmp, Colors.Black, Colors.Red, True)
				tMP.bmpIconBitMap1HL = bmpHL
			End If
		Else
			'Log(tMP.strTitle1 & ", tMP.iVerticalAdjust: " & tMP.iVerticalAdjust)
			Select Case tMP.iIconFont
				Case 1
					Dim bmp As Bitmap = TextToBitmap(Chr(tMP.iIconChar), 20, Colors.Black, 28, 28, _
					Typeface.FONTAWESOME,"CENTER", tMP.iVerticalAdjust, tMP.iHorizontalAdjust)
					tMP.bmpIconBitMap1 = bmp
					If tMP.iOverFlowGroup = -1 Then
						Dim bmpHL As Bitmap = ReplaceColor(bmp, Colors.Black, Colors.Red, True)
						tMP.bmpIconBitMap1HL = bmpHL
					End If
				Case 2
					Dim bmp As Bitmap = TextToBitmap(Chr(tMP.iIconChar), 20, Colors.Black, 28, 28, _
					Typeface.MATERIALICONS,"CENTER", tMP.iVerticalAdjust, tMP.iHorizontalAdjust)
					tMP.bmpIconBitMap1 = bmp
					If tMP.iOverFlowGroup = -1 Then
						Dim bmpHL As Bitmap = ReplaceColor(bmp, Colors.Black, Colors.Red, True)
						tMP.bmpIconBitMap1HL = bmpHL
					End If
			End Select
		End If
		
		If tMP.strIconFile2.Length > 0 Then
			Dim bmp As Bitmap = BitMapFromFile(File.DirAssets, tMP.strIconFile2, 0, 0, True)
			tMP.bmpIconBitMap2 = bmp
			If tMP.iOverFlowGroup = -1 Then
				Dim bmp2HL As Bitmap = ReplaceColor(bmp, Colors.Black, Colors.Red, True)
				tMP.bmpIconBitMap2HL = bmp2HL
			End If
		End If
		
		arrMenu(i) = tMP
		
	Next 'For i = 0 To lstCSV.Size - 1
	
	Log("arrMenu.Length: " & arrMenu.Length)
	
	Return True
	
End Sub

Sub BitMapFromFile(strFolder As String, strFile As String, iOldColour As Int, iNewColour As Int, bKeepAlphaLevel As Boolean) As Bitmap
	
	Dim bmp As Bitmap
	
	bmp = LoadBitmap(strFolder, strFile)
	
	If iOldColour <> iNewColour Then
		bmp = ReplaceColor(bmp, iOldColour, iNewColour, bKeepAlphaLevel)
	End If
	
	Return bmp
	
End Sub

Sub TextToBitmap(strText As String, FontSize As Float, lFontColour As Int, _
				 		 iWidth As Int, iHeight As Int, _
				 		 TF As Typeface, strAlignment As String, _
						 iVerticalAdjust As Int, iHorizontalAdjust As Int) As Bitmap
 
	Dim bmp As Bitmap
	Dim cvs As Canvas
	 
	bmp.InitializeMutable(iWidth * 100dip / 100, iHeight * 100dip / 100)
	cvs.Initialize2(bmp)
	Dim h As Double = cvs.MeasureStringHeight(strText, TF, FontSize)
	cvs.DrawText(strText, bmp.Width / 2 + iHorizontalAdjust, bmp.Height / 2 + h / 2 + iVerticalAdjust, _
				 TF, FontSize, lFontColour, strAlignment)
				 
	Return bmp
 
End Sub

Sub CreateBC(bmp As B4XBitmap) As BitmapCreator
	Dim bc As BitmapCreator
	bc.Initialize(bmp.Width / bmp.Scale, bmp.Height / bmp.Scale) '<<<< error here
	bc.CopyPixelsFromBitmap(bmp)
	Return bc
End Sub

'Replaces OldColor with NewColor.
'KeepAlphaLevel - If true then the alpha level of the source color is kept.
Sub ReplaceColor(bmp As B4XBitmap, OldColor As Int, NewColor As Int, KeepAlphaLevel As Boolean) As B4XBitmap
	
	Dim x As Int
	Dim y As Int
	Dim bc As BitmapCreator = CreateBC(bmp)
	Dim oldargb As ARGBColor
	Dim newargb As ARGBColor
	Dim a As ARGBColor
	
	bc.ColorToARGB(OldColor, oldargb)
	bc.ColorToARGB(NewColor, newargb)
	
	If KeepAlphaLevel Then
		For x = 0 To bc.mWidth - 1
			For y = 0 To bc.mHeight - 1
				bc.GetARGB(x, y, a)
				If a.r = oldargb.r And a.g = oldargb.g And a.b = oldargb.b Then
					newargb.a = a.a
					bc.SetARGB(x, y, newargb)
				End If
			Next
		Next
	Else
		For x = 0 To bc.mWidth - 1
			For y = 0 To bc.mHeight - 1
				bc.GetARGB(x, y, a)
				If a.a = oldargb.a And a.r = oldargb.r And a.g = oldargb.g And a.b = oldargb.b Then
					newargb.a = a.a
					bc.SetARGB(x, y, newargb)
				End If
			Next
		Next
	End If
	
	Return bc.Bitmap
	
End Sub

Sub CSV2List(strFolder As String, _
			 strFile As String, _
			 bFileHasFieldNames As Boolean, _
             btSeparatorByte As Byte, _
             btEncloserByte As Byte, _
			 bLookForEncloserByte As Boolean, _
             btEndOfLineByte As Byte, _
             lRows As Long) As ResumableSub

	Dim i As Long
	Dim c As Long
	Dim arrBytes() As Byte
	Dim lBytes As Long
	Dim lColumns As Long
	Dim lRow As Long
	Dim lUB As Long
	Dim lSeparatorPos As Long
	Dim lEncloserPos As Long
	Dim lChr10Pos As Long
	Dim arrFields() As Object
	Dim lstRows As List
	Dim lFirstDataByte As Long
	Dim bExit As Boolean
	Dim bCSVHasEncloserBytes As Boolean

	'this will be a zero-based UTF8 byte array
	'-----------------------------------------
	RAF.Initialize(strFolder, strFile, True)
	lBytes = RAF.Size
	'Log("CSV2List, lBytes: " & lBytes)
	Dim arrBytes(lBytes) As Byte
	RAF.ReadBytes(arrBytes, 0, lBytes, 0)
	
	lUB = arrBytes.Length - 1

	'General.StartSW(5)

	arrFields = GetCSVHeaders(arrBytes, btSeparatorByte, 34, 10)

	lColumns = arrFields.Length
	Dim arrData(lColumns) As String '<<<<<<<<<< was as Object!
	
	lstRows.Initialize
	
	If bFileHasFieldNames Then
		lstRows.Add(arrFields) 'adding the column names
		lRow = lRow + 1
		'as we are skipping the the column names
		'---------------------------------------
		lFirstDataByte = GetCSVFirstDataByte(arrBytes, 10)
	End If
	
	'so we ignore enclosers in the fields row!
	'-----------------------------------------
	If bLookForEncloserByte Then
		'if iBytesToCheckForEncloserByte = 0 then check all bytes, till one is found
		bCSVHasEncloserBytes = CSVHasEncloserBytes(arrBytes, lFirstDataByte, iBytesToCheckForEncloserByte, btEncloserByte)
	Else
		If btEncloserByte = -1 Then
			bCSVHasEncloserBytes = False
		Else
			bCSVHasEncloserBytes = True
		End If
	End If

	lEncloserPos = -1
	lSeparatorPos = -1
	lChr10Pos = lFirstDataByte - 1    '<<<<<<!!
	
	'deal with the first byte, taking this out speeds up the next loop a bit
	'-----------------------------------------------------------------------
	If bCSVHasEncloserBytes Then '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
		If lColumns > 1 Then '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			
			''''''''''''''''''''''''''
			'SEPARATORS AND ENCLOSERS'
			''''''''''''''''''''''''''
			Select Case arrBytes(lFirstDataByte)
				Case btSeparatorByte
					arrData(c) = "" '<<<<<<<<< was Null!
				Case btEncloserByte
					lEncloserPos = lFirstDataByte
			End Select

			For i = lFirstDataByte + 1 To lUB - 1
				Select Case arrBytes(i)
					Case btSeparatorByte
						If c < lColumns Then
							If lEncloserPos = -1 Then
								If lSeparatorPos = -1 Then
									If arrBytes(i - 1) <> btEncloserByte Then
										arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - 1) - lChr10Pos, "UTF-8")
										c = c + 1
										lChr10Pos = -1
									End If    'If arrBytes(i - 1) <> btEncloserByte
								Else    'If lSeparatorPos = -1
									If i - lSeparatorPos > 1 Then
										arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8")
									Else    'If (i - 1) - (lSeparatorPos + 1) > 1
										arrData(c) = "" '<<<<<<<<< was Null!
									End If    'If (i - 1) - (lSeparatorPos + 1) > 1
									c = c + 1
									lChr10Pos = -1
								End If    'If lSeparatorPos = -1
							End If    'If lEncloserPos = -1
						End If    'If c < lColumns
						lSeparatorPos = i
					Case btEncloserByte
						If lEncloserPos = -1 Then
							lEncloserPos = i
						Else
							If c < lColumns Then
								If i - lEncloserPos = 1 Then
									arrData(c) = "" '<<<<<<<<< was Null!
									c = c + 1
								Else    'If i - lEncloserPos = 1
									arrData(c) = BytesToString(arrBytes, lEncloserPos + 1, (i - 1) - lEncloserPos, "UTF-8")
									c = c + 1
								End If    'If i - lEncloserPos = 1
							End If    'If c < lColumns
							lEncloserPos = -1
						End If
						lSeparatorPos = -1
						lChr10Pos = -1
					Case btEndOfLineByte
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If arrBytes(i - 1) = 13 Then
									If (i - 2) - lSeparatorPos > 0 Then
										arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (i - 2) - lSeparatorPos, "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								Else    'If arrBytes(i - 1) = 13
									If (i - 1) - lSeparatorPos > 0 Then
										arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								End If    'If arrBytes(i - 1) = 13
							End If
					
							lstRows.Add(arrData)
							lRow = lRow + 1
							lEncloserPos = -1
							lSeparatorPos = -1
							lChr10Pos = i
							c = 0
							Dim arrData(lColumns) As String
						End If    'If lEncloserPos = -1
				End Select
				If bExit Then Exit
			Next
	
			'deal with the last byte, this is needed for if there is no final linebreak
			'--------------------------------------------------------------------------
			If lRows = -1 Then
				Select Case arrBytes(lUB)
					Case btSeparatorByte
						If c < lColumns Then
							If lEncloserPos = -1 Then
								If lSeparatorPos = -1 Then
									If lUB - lChr10Pos = 1 Then
										arrData(c) = "" '<<<<<<<<< was Null!
									Else    'If lUB - lChr10Pos = 1
										If arrBytes(lUB - 1) <> btEncloserByte Then
											arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 1) - lChr10Pos, "UTF-8")
										End If
									End If    'If lUB - lChr10Pos = 1
								End If    'If lSeparatorPos = -1
							Else    'If lEncloserPos = -1
								If lUB - lSeparatorPos = 1 Then
									arrData(c) = "" '<<<<<<<<< was Null!
								End If
							End If    'If lEncloserPos = -1
						End If    'If collStrings.Count < lColumns
					Case btEncloserByte
						If lEncloserPos > -1 Then
							If c < lColumns Then
								If lUB - lEncloserPos = 1 Then
									arrData(c) = "" '<<<<<<<<< was Null!
								Else    'If lUB - lEncloserPos = 1
									arrData(c) = BytesToString(arrBytes, lEncloserPos + 1, (lUB - 1) - lEncloserPos, "UTF-8")
								End If    'If lUB - lEncloserPos = 1
							End If    'If c < lColumns
						End If    'If lEncloserPos > -1
					Case btEndOfLineByte
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If lSeparatorPos > -1 Then
									If arrBytes(lUB - 1) = 13 Then
										If lUB - lSeparatorPos > 2 Then
											arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (lUB - 1) - lSeparatorPos, "UTF-8")
										Else
											arrData(c) = "" '<<<<<<<<< was Null!
										End If
									Else    'If arrBytes(lUB - 1) = 13
										If lUB - lSeparatorPos > 1 Then
											arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (lUB - 2) - lSeparatorPos, "UTF-8")
										Else
											arrData(c) = "" '<<<<<<<<< was Null!
										End If
									End If    'If arrBytes(lUB - 1) = 13
								Else    'If lSeparatorPos > -1
									If lChr10Pos > -1 Then
										If arrBytes(lUB - 1) = 13 Then
											arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 2) - lChr10Pos, "UTF-8")
										Else
											arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 1) - lChr10Pos, "UTF-8")
										End If
									Else    'If lChr10Pos > -1
										If arrBytes(lUB - 2) <> btEncloserByte Then
											If arrBytes(lUB - 1) = 13 Then
												arrData(c) = BytesToString(arrBytes, 0, lUB - 2, "UTF-8")
											Else
												arrData(c) = BytesToString(arrBytes, 0, lUB - 1, "UTF-8")
											End If
										End If    'If arrBytes(lUB - 2) <> btEncloserByte
									End If    'If lChr10Pos > -1
								End If    'If lSeparatorPos > -1
							End If    'If c < lColumns
						End If    'If lEncloserPos = -1
					Case Else
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If lSeparatorPos > -1 Then
									If lUB - lSeparatorPos > 1 Then
										arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, lUB - lSeparatorPos, "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
								Else    'If lSeparatorPos > -1
									If lChr10Pos > -1 Then
										arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, lUB - lChr10Pos, "UTF-8")
									Else
										arrData(c) = BytesToString(arrBytes, lFirstDataByte, (lUB - lFirstDataByte) + 1, "UTF-8")
									End If
								End If    'If lSeparatorPos > -1
							End If    'If c < lColumns
						End If    'If lEncloserPos = -1
				End Select
			End If
		
		Else 'If lColumns > 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
			'''''''''''''''''''''''''''''
			'NO SEPARATORS BUT ENCLOSERS'
			'''''''''''''''''''''''''''''
			Select Case arrBytes(lFirstDataByte)
				Case btEncloserByte
					lEncloserPos = lFirstDataByte
			End Select

			For i = lFirstDataByte + 1 To lUB - 1
				Select Case arrBytes(i)
					Case btEncloserByte
						If lEncloserPos = -1 Then
							lEncloserPos = i
						Else
							If c < lColumns Then
								If i - lEncloserPos = 1 Then
									arrData(c) = "" '<<<<<<<<< was Null!
									c = c + 1
								Else    'If i - lEncloserPos = 1
									arrData(c) = BytesToString(arrBytes, lEncloserPos + 1, (i - 1) - lEncloserPos, "UTF-8")
									c = c + 1
								End If    'If i - lEncloserPos = 1
							End If    'If c < lColumns
							lEncloserPos = -1
						End If
						lChr10Pos = -1
					Case btEndOfLineByte
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If arrBytes(i - 1) = 13 Then
									If (i - lChr10Pos) -1 > 1 Then
										arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - lChr10Pos) -1 , "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								Else    'If arrBytes(i - 1) = 13
									If (i - lChr10Pos) > 1 Then
										arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - lChr10Pos) , "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								End If    'If i - lSeparatorPos > 1
							End If    'If c < lColumns
					
							lstRows.Add(arrData)
							lRow = lRow + 1
							lEncloserPos = -1
							lChr10Pos = i
							c = 0
							Dim arrData(lColumns) As String

							If lRows > -1 Then
								If lRow > lRows Then
									bExit = True
								End If
							End If
						End If    'If lEncloserPos = -1
				End Select
				If bExit Then Exit
			Next
	
			'deal with the last byte, this is needed for if there is no final linebreak
			'--------------------------------------------------------------------------
			If lRows = -1 Then
				Select Case arrBytes(lUB)
					Case btEncloserByte
						If lEncloserPos > -1 Then
							If c < lColumns Then
								If lUB - lEncloserPos = 1 Then
									arrData(c) = "" '<<<<<<<<< was Null!
								Else    'If lUB - lEncloserPos = 1
									arrData(c) = BytesToString(arrBytes, lEncloserPos + 1, (lUB - 1) - lEncloserPos, "UTF-8")
								End If    'If lUB - lEncloserPos = 1
							End If    'If c < lColumns
						End If    'If lEncloserPos > -1
					Case btEndOfLineByte
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If lChr10Pos > -1 Then
									If arrBytes(lUB - 1) = 13 Then
										If (lUB - 2) - lChr10Pos > 0 Then
											arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 2) - lChr10Pos, "UTF-8")
										Else
											arrData(c) = "" '<<<<<<<<< was Null!
										End If
									Else
										If (lUB - 1) - lChr10Pos > 0 Then
											arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 1) - lChr10Pos, "UTF-8")
										Else
											arrData(c) = "" '<<<<<<<<< was Null!
										End If
									End If
								Else    'If lChr10Pos > -1
									If arrBytes(lUB - 2) <> btEncloserByte Then
										If arrBytes(lUB - 1) = 13 Then
											arrData(c) = BytesToString(arrBytes, 0, lUB - 2, "UTF-8")
										Else
											arrData(c) = BytesToString(arrBytes, 0, lUB - 1, "UTF-8")
										End If
									End If    'If arrBytes(lUB - 2) <> btEncloserByte
								End If    'If lChr10Pos > -1
							End If    'If c < lColumns
						End If    'If lEncloserPos = -1
					Case Else
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If lChr10Pos > -1 Then
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, lUB - lChr10Pos, "UTF-8")
								Else
									arrData(c) = BytesToString(arrBytes, lFirstDataByte, (lUB - lFirstDataByte) + 1, "UTF-8")
								End If
							End If    'If c < lColumns
						End If    'If lEncloserPos = -1
				End Select
			End If
		End If 'If lColumns > 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
	Else  'If bCSVHasEncloserBytes<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
		'''''''''''''''''''''''''''''
		'SEPARATORS BUT NO ENCLOSERS'
		'''''''''''''''''''''''''''''
		If lColumns > 1 Then '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			Select Case arrBytes(lFirstDataByte)
				Case btSeparatorByte
					arrData(c) = "" '<<<<<<<<< was Null!
			End Select

			For i = lFirstDataByte + 1 To lUB - 1
				Select Case arrBytes(i)
					Case btSeparatorByte
						If c < lColumns Then
							If lSeparatorPos = -1 Then
								arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - 1) - lChr10Pos, "UTF-8")
								c = c + 1
								lChr10Pos = -1
							Else    'If lSeparatorPos = -1
								If i - lSeparatorPos > 1 Then
									arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8")
								Else    'If (i - 1) - (lSeparatorPos + 1) > 1
									arrData(c) = "" '<<<<<<<<< was Null!
								End If    'If (i - 1) - (lSeparatorPos + 1) > 1
								c = c + 1
								lChr10Pos = -1
							End If    'If lSeparatorPos = -1
						End If    'If c < lColumns
						lSeparatorPos = i
					Case btEndOfLineByte
						If c < lColumns Then
							If lSeparatorPos > -1 Then
								If arrBytes(i - 1) = 13 Then
									If (i - 2) - lSeparatorPos > 0 Then
										arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (i - 2) - lSeparatorPos, "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								Else    'If arrBytes(i - 1) = 13
									If (i - 1) - lSeparatorPos > 0 Then
										arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								End If    'If arrBytes(i - 1) = 13
							Else    'If lSeparatorPos > -1
								If arrBytes(i - 1) = 13 Then
									If (i - lChr10Pos) -1 > 1 Then
										arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - lChr10Pos) -1 , "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								Else    'If arrBytes(i - 1) = 13
									If (i - lChr10Pos) > 1 Then
										arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - lChr10Pos) , "UTF-8")
									Else
										arrData(c) = "" '<<<<<<<<< was Null!
									End If
									c = c + 1
								End If    'If i - lSeparatorPos > 1
							End If    'If lSeparatorPos > -1
					
							lstRows.Add(arrData)
							lRow = lRow + 1
'							If lRow = 91 Then
'								Log("91")
'							End If
							lSeparatorPos = -1
							lChr10Pos = i
							c = 0
							Dim arrData(lColumns) As String

							If lRows > -1 Then
								If lRow > lRows Then
									bExit = True
								End If
							End If
						End If    'If lEncloserPos = -1
				End Select
				If bExit Then Exit
			Next
	
			'deal with the last byte, this is needed for if there is no final linebreak
			'--------------------------------------------------------------------------
			If lRows = -1 Then
				Select Case arrBytes(lUB)
					Case btSeparatorByte
						If c < lColumns Then
							If lSeparatorPos = -1 Then
								If lUB - lChr10Pos = 1 Then
									arrData(c) = "" '<<<<<<<<< was Null!
								Else    'If lUB - lChr10Pos = 1
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 1) - lChr10Pos, "UTF-8")
								End If    'If lUB - lChr10Pos = 1
							End If    'If lSeparatorPos = -1
						End If    'If collStrings.Count < lColumns
					Case btEndOfLineByte
						If lEncloserPos = -1 Then
							If c < lColumns Then
								If lSeparatorPos > -1 Then
									If arrBytes(lUB - 1) = 13 Then
										If lUB - lSeparatorPos > 2 Then
											arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (lUB - 1) - lSeparatorPos, "UTF-8")
										Else
											arrData(c) = "" '<<<<<<<<< was Null!
										End If
									Else    'If arrBytes(lUB - 1) = 13
										If lUB - lSeparatorPos > 1 Then
											arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, (lUB - 2) - lSeparatorPos, "UTF-8")
										Else
											arrData(c) = "" '<<<<<<<<< was Null!
										End If
									End If    'If arrBytes(lUB - 1) = 13
								Else    'If lSeparatorPos > -1
									If lChr10Pos > -1 Then
										If arrBytes(lUB - 1) = 13 Then
											If (lUB - 2) - lChr10Pos > 0 Then
												arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 2) - lChr10Pos, "UTF-8")
											Else
												arrData(c) = "" '<<<<<<<<< was Null!
											End If
										Else
											If (lUB - 1) - lChr10Pos > 0 Then
												arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 1) - lChr10Pos, "UTF-8")
											Else
												arrData(c) = "" '<<<<<<<<< was Null!
											End If
										End If
									Else    'If lChr10Pos > -1
										If arrBytes(lUB - 1) = 13 Then
											arrData(c) = BytesToString(arrBytes, 0, lUB - 2, "UTF-8")
										Else
											arrData(c) = BytesToString(arrBytes, 0, lUB - 1, "UTF-8")
										End If
									End If    'If lChr10Pos > -1
								End If    'If lSeparatorPos > -1
							End If    'If c < lColumns
						End If    'If lEncloserPos = -1
					Case Else
						If c < lColumns Then
							If lSeparatorPos > -1 Then
								If lUB - lSeparatorPos > 1 Then
									arrData(c) = BytesToString(arrBytes, lSeparatorPos + 1, lUB - lSeparatorPos, "UTF-8")
								Else
									arrData(c) = "" '<<<<<<<<< was Null!
								End If
							Else    'If lSeparatorPos > -1
								If lChr10Pos > -1 Then
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, lUB - lChr10Pos, "UTF-8")
								Else
									arrData(c) = BytesToString(arrBytes, lFirstDataByte, (lUB - lFirstDataByte) + 1, "UTF-8")
								End If
							End If    'If lSeparatorPos > -1
						End If    'If c < lColumns
				End Select
			End If
		
		Else 'If lColumns > 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
			''''''''''''''''''''''''''''''''
			'NO SEPARATORS AND NO ENCLOSERS'
			''''''''''''''''''''''''''''''''
			For i = lFirstDataByte + 1 To lUB - 1
				Select Case arrBytes(i)
					Case btEndOfLineByte
						If c < lColumns Then
							If arrBytes(i - 1) = 13 Then
								If (i - lChr10Pos) -1 > 0 Then
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - lChr10Pos) -1 , "UTF-8")
								Else
									arrData(c) = "" '<<<<<<<<< was Null!
								End If
								c = c + 1
							Else    'If arrBytes(i - 1) = 13
								If (i - lChr10Pos) > 0 Then
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (i - lChr10Pos) , "UTF-8")
								Else
									arrData(c) = "" '<<<<<<<<< was Null!
								End If
								c = c + 1
							End If    'If i - lSeparatorPos > 1
						End If    'If c < lColumns
					
						lstRows.Add(arrData)
						lRow = lRow + 1
						lChr10Pos = i
						c = 0
						Dim arrData(lColumns) As String

						If lRows > -1 Then
							If lRow > lRows Then
								bExit = True
							End If
						End If
				End Select
				If bExit Then Exit
			Next
	
			'deal with the last byte, this is needed for if there is no final linebreak
			'--------------------------------------------------------------------------
			If lRows = -1 Then
				Select Case arrBytes(lUB)
					Case btEndOfLineByte
						If c < lColumns Then
							If lChr10Pos > -1 Then
								If arrBytes(lUB - 1) = 13 Then
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 2) - lChr10Pos, "UTF-8")
								Else
									arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, (lUB - 1) - lChr10Pos, "UTF-8")
								End If
							Else    'If lChr10Pos > -1
								If arrBytes(lUB - 1) = 13 Then
									arrData(c) = BytesToString(arrBytes, 0, lUB - 2, "UTF-8")
								Else
									arrData(c) = BytesToString(arrBytes, 0, lUB - 1, "UTF-8")
								End If
							End If    'If lChr10Pos > -1
						End If    'If c < lColumns
					Case Else
						If c < lColumns Then
							If lChr10Pos > -1 Then
								arrData(c) = BytesToString(arrBytes, lChr10Pos + 1, lUB - lChr10Pos, "UTF-8")
							Else
								arrData(c) = BytesToString(arrBytes, lFirstDataByte, (lUB - lFirstDataByte) + 1, "UTF-8")
							End If
						End If    'If c < lColumns
				End Select
			End If
		End If 'If lColumns > 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
	End If 'If bCSVHasEncloserBytes<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	'add final data array
	lstRows.Add(arrData)
	
	Log("lstRows.Size: " & lstRows.Size)
	
	Return lstRows

End Sub

Sub GetCSVHeaders(arrBytes() As Byte, _
                  btSeparatorByte As Byte, _
                  btEncloserByte As Byte, _
                  btEndOfLineByte As Byte) As String()

	Dim i As Long
	Dim c As Long
	Dim lUB As Long
	Dim lSeparatorPos As Long
	Dim lEncloserPos As Long
	Dim lChr10Pos As Long
	Dim lstFields As List
	Dim bNoEnclosers As Boolean
	Dim bExitLoop As Boolean

	lUB = arrBytes.Length - 1
	bNoEnclosers = btEncloserByte = -1

	lEncloserPos = -1
	lSeparatorPos = -1
	lChr10Pos = -1

	lstFields.Initialize
	
	If bNoEnclosers Then 'no enclosers
		For i = 0 To lUB
			Select Case arrBytes(i)
				Case btSeparatorByte
					If lSeparatorPos = -1 Then
						If i - lChr10Pos = 1 Then
							bExitLoop = True
						Else
							lstFields.Add(BytesToString(arrBytes, lChr10Pos + 1, (i - 1) - lChr10Pos, "UTF-8"))
							c = c + 1
							lChr10Pos = -1
						End If
					Else
						If i - lSeparatorPos > 1 Then
							lstFields.Add(BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8"))
						Else
							bExitLoop = True
						End If
						c = c + 1
						lChr10Pos = -1
					End If
					lSeparatorPos = i
				Case btEndOfLineByte
					If lSeparatorPos > -1 Then
						If arrBytes(i - 1) = 13 Then
							If i - lSeparatorPos > 2 Then
								lstFields.Add(BytesToString(arrBytes, lSeparatorPos + 1, (i - 2) - lSeparatorPos, "UTF-8"))
								c = c + 1
							Else
								bExitLoop = True
							End If
						Else
							If i - lSeparatorPos > 1 Then
								lstFields.Add(BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8"))
								c = c + 1
							Else
								bExitLoop = True
							End If
						End If
					Else    'If lSeparatorPos > -1
						If lChr10Pos > -1 Then
							If arrBytes(i - 1) = 13 Then
								lstFields.Add(BytesToString(arrBytes, lChr10Pos + 1, (i - 2) - lChr10Pos, "UTF-8"))
							Else
								lstFields.Add(BytesToString(arrBytes, lChr10Pos + 1, (i - 1) - lChr10Pos, "UTF-8"))
							End If
							c = c + 1
						Else
							If arrBytes(i - 1) = 13 Then
								lstFields.Add(BytesToString(arrBytes, 0, i - 1, "UTF-8"))
							Else
								lstFields.Add(BytesToString(arrBytes, 0, i, "UTF-8"))
							End If
							c = c + 1
						End If
					End If    'If lSeparatorPos > -1
					bExitLoop = True
			End Select
			If bExitLoop Then Exit
		Next
	Else  'If bNoEnclosers
		For i = 0 To lUB
			Select Case arrBytes(i)
				Case btSeparatorByte
					If lEncloserPos = -1 Then
						If lSeparatorPos = -1 Then
							If i - lChr10Pos = 1 Then
								bExitLoop = True
							Else
								If arrBytes(i - 1) <> btEncloserByte Then
									lstFields.Add(BytesToString(arrBytes, lChr10Pos + 1, (i - 1) - lChr10Pos, "UTF-8"))
									c = c + 1
									lChr10Pos = -1
								End If
							End If
						Else
							If i - lSeparatorPos > 1 Then
								lstFields.Add(BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8"))
							Else
								bExitLoop = True
							End If
							c = c + 1
							lChr10Pos = -1
						End If
					Else
						If i - lSeparatorPos = 1 Then
							bExitLoop = True
						End If
					End If
					lSeparatorPos = i
				Case btEncloserByte
					If lEncloserPos = -1 Then
						lEncloserPos = i
					Else
						If i - lEncloserPos = 1 Then
							bExitLoop = True
						Else
							lstFields.Add(BytesToString(arrBytes, lEncloserPos + 1, (i - 1) - lEncloserPos, "UTF-8"))
							c = c + 1
						End If
						lEncloserPos = -1
					End If
					lSeparatorPos = -1
					lChr10Pos = -1
				Case btEndOfLineByte
					If lEncloserPos = -1 Then
						If lSeparatorPos > -1 Then
							If arrBytes(i - 1) = 13 Then
								If i - lSeparatorPos > 2 Then
									lstFields.Add(BytesToString(arrBytes, lSeparatorPos + 1, (i - 2) - lSeparatorPos, "UTF-8"))
									c = c + 1
								Else
									bExitLoop = True
								End If
							Else
								If i - lSeparatorPos > 1 Then
									lstFields.Add(BytesToString(arrBytes, lSeparatorPos + 1, (i - 1) - lSeparatorPos, "UTF-8"))
									c = c + 1
								Else
									bExitLoop = True
								End If
							End If
						Else    'If lSeparatorPos > -1
							If lChr10Pos > -1 Then
								If arrBytes(i - 1) = 13 Then
									lstFields.Add(BytesToString(arrBytes, lChr10Pos + 1, (i - 2) - lChr10Pos, "UTF-8"))
								Else
									lstFields.Add(BytesToString(arrBytes, lChr10Pos + 1, (i - 1) - lChr10Pos, "UTF-8"))
								End If
								c = c + 1
							Else
								If arrBytes(i - 2) <> btEncloserByte Then
									If arrBytes(i - 1) <> btEncloserByte Then
										If arrBytes(i - 1) = 13 Then
											lstFields.Add(BytesToString(arrBytes, 0, i - 1, "UTF-8"))
										Else
											lstFields.Add(BytesToString(arrBytes, 0, i, "UTF-8"))
										End If
										c = c + 1
									End If
								End If
							End If
						End If    'If lSeparatorPos > -1
						bExitLoop = True
					End If    'If lEncloserPos = -1
			End Select
			If bExitLoop Then Exit
		Next
	End If  'If bNoEnclosers

	Dim arrFields(lstFields.Size) As String

	For i = 0 To lstFields.Size - 1
		arrFields(i) = lstFields.Get(i)
	Next

	Return arrFields

End Sub

Sub GetCSVFirstDataByte(arrBytes() As Byte, btEndOfLineByte As Byte) As Long

	Dim i As Long

	For i = 0 To arrBytes.Length - 1
		If arrBytes(i) = btEndOfLineByte Then
			Return i + 1
		End If
	Next
	
	Return -1

End Sub

Sub CSVHasEncloserBytes(arrBytes() As Byte, lFirstByte As Long, lBytesToCheck As Long, btEncloserByte As Byte) As Boolean
	
	Dim i As Long
	Dim lUB As Long
	
	If lBytesToCheck = 0 Then
		lUB = arrBytes.Length - 1
	Else
		lUB = lBytesToCheck - 1
		If lUB > arrBytes.Length -1 Then
			lUB = arrBytes.Length -1
		End If
	End If

	For i = lFirstByte To lUB
		If arrBytes(i) = btEncloserByte Then
			Return True
		End If
	Next
	
	Return False
	
End Sub
